
function [X, dWDeltat] = DownSample_Data(data_fm,rmInfo)
%% downsample data to have Deltat = obsgap*dt 
obsgap = rmInfo.obsgap; 
tInd   = 1:obsgap:data_fm.tN;   % time index for downsample the data
X      = data_fm.X(:,tInd);      % array of the downsampled state trajectory
[dimX,tN] = size(X); 
dWdt      = data_fm.dWdt;           % array of the full noise trajectory
dWDeltat = zeros(dimX,tN-1); 
for i=1:tN-1
    temp_Indt   = obsgap*(i-1)+(1:1:obsgap); 
    temp_dW  = dWdt(:,temp_Indt);  
    dWDeltat(:,i) = sum(temp_dW,2); 
end
end 