
%% test convergence of coefficients in the inferred scheme

settings_inferScheme;    
rmInfo

gapseq   = [1, 10, 20, 40, 80, 160, 200, 320];
L_gapseq = length(gapseq);

estimatorCov_file  = strrep(rmInfo.estimator_filename,'.mat', ['_cov.mat']);  % file name

if ~exist(estimatorCov_file,'file')
    estimatorSeq = cell(L_gapseq,1);
    for ll=1:L_gapseq
        obsgap = gapseq(ll);
        rmInfo.obsgap = obsgap;
        rmInfo.deltat = fmDataInfo.dt* obsgap;
        %% downsample data and estimate the parameters
        [X, dWDeltat] = DownSample_Data(data_fm,rmInfo); % downsample data ; dWDeltat ~ sqrt(deltat)*Bn
        
        [cvec,res,LSE_Abres] = estimatePara_MLE(X, dWDeltat,rmInfo,sysInfo);
        estimatorSeq{ll}.cvec = cvec;
        estimatorSeq{ll}.res  = res;
        estimatorSeq{ll}.LSE_Abres = LSE_Abres;
        
        fprintf('Estimated para with deltat=%2.4f (Gap = %i):\n',deltat, obsgap); disp(cvec');
        fprintf('sqrt(residual)*deltat %2.4f \n',sqrt(res)*deltat,sqrt(deltat*2/sysInfo.beta));
    end
    save(estimatorCov_file, 'rmInfo', 'sysInfo','fmDataInfo','estimatorSeq','gapseq');  
end

load(estimatorCov_file); 

%% plot the results
%{
convengence of the coefficents cvec and covergence of res. 
%}
