
function lseAb_1traj = inferFrom1traj_demo(u0,parOM,rmInfo,noiseON, printON, fileMLE)
% Inference from 1 trajectory
%  + estimators from data traj with different length; 
%  + 
% The time series model
%          qp_c  = coefs *termsInUse + Niose
% Output
%    - 

%% set length of each piece of trajectory
trajL_seq   = rmInfo.trajL_seq;       trajL_seqN  = length(trajL_seq);  % 10*[1,2,4,8,16,32,64]; 
obsGap_seq  = rmInfo.obsGap_seq;      obsGap_seqN = length(obsGap_seq); % 1* [1,2,4,6,8,10,12]; 
lseAb_1traj = cell(trajL_seqN,obsGap_seqN);  % all LSE_Abres in a cell array

%%  
parOM_temp = parOM;  Lag = rmInfo.wlag;  indLagtermsV = rmInfo.indLagtermsV;
tic 
if exist('printON','var') && printON ==1; fprintf('\n \n Progress: ');  Progress_reverseStr = []; end
for jj= 1:trajL_seqN
    if exist('printON','var') && printON ==1
        perctage            = 0.5*100*trajL_seq(jj)/trajL_seq(end);
        Progress_reverseStr = displayprogress(perctage, Progress_reverseStr); pause(0.02); % display progress
    end
    if jj>1; trajTimeGap = trajL_seq(jj) - trajL_seq(jj-1); else; trajTimeGap = trajL_seq(jj); end
     parOM_temp.tN = trajTimeGap/parOM.dt;             % NOTE: only the increment interval 
    [vobs,u0,noiseObs] = generateData(u0,parOM_temp,rmInfo); % vobs = Fourier coefs with wavenumber 1:K
    for ii = 1:obsGap_seqN
        gap = obsGap_seq(ii);
        [rmInfo1,vobs1,noiseObs1] = DownSample_Data(gap,vobs,noiseObs,rmInfo,parOM);
        [qp_c,termsWb,termsV,~] = terms_from_1traj(vobs1,noiseObs1,rmInfo1,Lag,noiseON);
        termsV     = termsV(indLagtermsV,:,:);
        termsInUse = [termsV; termsWb];
        [~,~,LSE_Abres]       = LSEAxb_cmodes(qp_c,termsInUse,0); % same as LSEAxb
        lseAb_1traj{jj,ii}    = LSE_Abres; 
        lseAb_1traj{jj,ii}.tN = parOM_temp.tN; 
    end
end
lseAb_1traj = LSEab_sumInTime(lseAb_1traj); 
time1traj = toc; 
    lseAb_1traj{end,end}.trajL_seq  = trajL_seq; 
    lseAb_1traj{end,end}.obsGap_seq = obsGap_seq; 
    lseAb_1traj{end,end}.time1traj  = time1traj; 

if exist('printON','var') && printON ==1
    lseAb_all = cell(1,1); 
    lseAb_all{1} = lseAb_1traj; parOM.u0fn = 0; 
    save dataTemp.mat parOM rmInfo lseAb_all;
    movefile('dataTemp.mat', fileMLE);
end
end



function [rmInfo1,vobs,noiseObs] = DownSample_Data(gap,vobs,noiseObs,rmInfo, parOM)
% downsampling accoding to gap: using the same data for different gaps and Lags

rmInfo1  = rmInfo;                              
if gap > rmInfo.obsgap     % data downsampling
    ratio = gap/rmInfo.obsgap; rmInfo1.obsgap = gap; rmInfo1.deltat = gap* parOM.dt; 
    tt    = 1:ratio:length(vobs(1,:));  ttL = length(tt);
    vobs  = vobs(:,tt);   noiseObs1 = 0* vobs(:,1:end-1);
    for ll= 1:ttL-1
        indtemp = tt(ll):tt(ll+1)-1;
        noiseObs1(:,ll) = sum(noiseObs(:,indtemp),2);
    end
    noiseObs = noiseObs1;
end

end


function lseAb_1traj = LSEab_sumInTime(lseAb_1traj)
% add the lseAb_1traj.Amat and b in time; because each is compuate in the
% inrement time interval. 
%{
regression solution: c = A\b; 
resvec = \sum_n |y_n - c phi(x_n)|^2 =  alpha - 2 c'b + c'Ac = alpha - c'b;

lseAb_1traj.
          Amat: [Npar×Npar×K double]
          bvec: [Npar×K double]
        resvec: [1xK]  
          cvec: [Npar×K double]
      cvecPinv: [Npar×K double]
    resvecPinv: [1xK]
%}

[tseqL, gapSeqL ] =size(lseAb_1traj);
K   = length(lseAb_1traj{1,1}.resvec); 
for jj = 1: gapSeqL
    Amat1   = lseAb_1traj{1,jj}.Amat;     bvec1      = lseAb_1traj{1,jj}.bvec; 
    resvec  = lseAb_1traj{1,jj}.resvec;   resvecPinv = lseAb_1traj{1,jj}.resvecPinv; 
    cvec1    = lseAb_1traj{1,jj}.cvec;    cvecPinv1  = lseAb_1traj{1,jj}.cvecPinv; 
    alpha1  = resvec + sum(cvec1.*bvec1); alphaPinv1 = resvecPinv + sum(cvecPinv1.*bvec1);
    N1    = lseAb_1traj{1,jj}.tN;   
    for ii = 2:tseqL
        % length and ratio between two sets of data with size N1 and N2 
        N2      = lseAb_1traj{ii,jj}.tN;  a1 = N1/(N1+N2); a2 = N2/(N1+N2); N1 = N1+N2; 
        
       % update cvec = Amat\bvec: updates to Amat1, bvec1 and cvec1
        Amat2   = lseAb_1traj{ii,jj}.Amat;     bvec2     = lseAb_1traj{ii,jj}.bvec; 
        Amat1   = a1* Amat1 + a2* Amat2;       bvec1     = a1* bvec1 + a2*bvec2;      
        for kk=1:K
            Atemp   = Amat1(:,:,kk);
            cvec1(:,kk)   = Atemp\bvec1(:,kk);       cvecPinv1(:,kk)  = pinv(Atemp)*bvec1(:,kk);
        end
        % update residual resvec: res = |y_i - sum_j c_j phi_j(x_i)|^2
        resvec  = lseAb_1traj{ii,jj}.resvec;   resvecPinv = lseAb_1traj{ii,jj}.resvecPinv;
        cvec2   = lseAb_1traj{ii,jj}.cvec;     cvecPinv2  = lseAb_1traj{ii,jj}.cvecPinv;
        alpha2  = resvec + sum(cvec2.*bvec2);  alphaPinv2 = resvecPinv + sum(cvecPinv2.*bvec2);
        alpha1  = a1*alpha1 + a2*alpha2;       alphaPinv1 = a1*alphaPinv1 + a2*alphaPinv2;
        resvec1 = alpha1 - sum(cvec1.*bvec1);  resvecPinv1= alphaPinv1  - sum(cvecPinv1.*bvec1);

        % save to lseAb_1traj
        lseAb_1traj{ii,jj}.Amat   = Amat1;   lseAb_1traj{ii,jj}.bvec       = bvec1;
        lseAb_1traj{ii,jj}.cvec   = cvec1;   lseAb_1traj{ii,jj}.cvecPinv   = cvecPinv1;
        lseAb_1traj{ii,jj}.resvec = resvec1; lseAb_1traj{ii,jj}.resvecPinv = resvecPinv1;
    end
end

end