function terms = termsEuler(Yn,term_gradV,deltat,useNoise,Bn)
% the terms in EulerScheme for inference
% Euler form     Y(n+1) = Yn - deltat * termsEuler(Yn,deltat) + sigma1*sqrt(deltat)*Bn 
%                termsEuler(Yn,deltat) =  [c0.*Yn - c1* gradV(Yn)]   
% Note that Yn is a vector, so c0 is also a vector
if ~exist('useNoise','var'); useNoise = 0; end
if useNoise == 0
    terms    = cell(2,1); 
    terms{1} = Yn;
    terms{2} = -term_gradV(Yn);
else
    terms    = cell(3,1); 
    terms{1} = Yn;
    terms{2} = -term_gradV(Yn);
    terms{3} = Bn/deltat; 
end
end