 
saveON =0;  

% Plots the full system:  
 [XX,YY]               = meshgrid(sysInfo.xgrid,sysInfo.ygrid);
 ZZ                    = sysInfo.potential_V(XX,YY);
 X                     = data_fm.X;
 
 figure(1)    % contour plot of the potential
 contourf(XX,YY,min(ZZ,200),40); colormap cool
 title('contour plot of the potential','FontSize',14); setPlot_fontSize;
 if saveON ==1; filename = [fmDataInfo.datapath, 'fig_potential']; print(filename,'-dpdf'); end
 
 figure(2)    % scatter of (x1,x2)
 X_plot = X(:,1:100:end);
 plot(X_plot(1,:),X_plot(2,:),'.'); xlabel('x'); ylabel('y');
 title('Sample every 100 steps','FontSize',14); setPlot_fontSize;
 if saveON ==1; filename = [fmDataInfo.datapath, 'fig_sampleScatter']; myprintPDF(filename); end
 
 
figure(11)       % plot the move of the particle along the poential valley
ttN     =  length(X_plot(1,:));    % length of plotted 
tt      =1:ceil(ttN/1000):ttN;
  for i = 1:length(tt)
     plot(X_plot(1,tt(i)),X_plot(2,tt(i)),'.'); hold on; pause(0.01);
  end
 
 %{
 TO BE DONE: plot the a trectory 
 figure(12)       % plot a trajectory with color depth in time 
ttN        =  length(X_plot(1,:));    % length of plotted 
 newcolors = [0.83 0.14 0.14
             1.00 0.54 0.00
             0.47 0.25 0.80
             0.25 0.80 0.54];
         
colororder(newcolors)
 for t = 1:length(X_plot(1,:))
     plot(X_plot(1,t),X_plot(2,t),'.');
 end
 %}