function compareStats(xrm,Xtrue,timeLag,deltat,estimator_filename,figpath,figname0,corr_true) 

%% TBD
%% compare the stats of the reduced model with the data
tN = length(xrm); tInd =1:ceil(tN/2000):tN; tt = tInd*deltat; 
% compare trajectory
figure(60);clf
subplot(131);  plot(tt, xrm(tInd),'b');  hold on; plot(tt, Xtrue(tInd),'k-.'); 
   legend('Reproduced','True'); title('Trajectory of x1'); xlabel('Time t'); ylabel('x1'); 
%   figname = [figpath,figname0,'_traj']; print([figname,'.eps'],'-depsc');
   
% compare pdf
subplot(132); 
   [fiTrue,xiTrue] = ksdensity(real(Xtrue(1,:)));  
   [fiRM,xiRM]     = ksdensity(real(xrm(1,:)),xiTrue);
   h = plot(xiRM,fiRM,'b',xiTrue,fiTrue,'k-.'); set(h,{'LineWidth'},{1})
   xlabel('x1'); ylabel('PDF'); title('PDF of x1'); 
  % legend('Reproduced','True'); 
   
% compare correlation
if ~exist('xrm_corr','var')
    xrm_corr = temporal_corr(xrm,timeLag);
    save(estimator_filename,'xrm_corr','timeLag','deltat','-append');
end
tt = deltat*(0:timeLag);
subplot(133); 
   plot(tt,xrm_corr/xrm_corr(1,1),'b','linewidth',1); hold on; 
   plot(tt,corr_true/corr_true(1,1),'k-.','linewidth',1); 
   title('Correlation of x1'); xlabel('Time Lag t'); ylabel('ACF'); legend('Reproduced','True');
%   figname = [figpath,figname0,'_acf']; print(figname,'-depsc');
   
 set_positionFonts;
 set(gcf,'Position',  [100, 1000, 1200, 400]);tightfig;
 figname = [figpath,figname0,'_all.eps']; print(figname,'-depsc');
end

