function [rel_err_var,TV_RMvsTrue, TV_RM0vsTrue,scheme_cmp,blowupFlag,blowupEuler] = compare_1traj(X,dWDeltat,cvec,res,rmInfo,sysInfo,fmDataInfo,gapInd)
% compare the PDF and ACF from 1 trajectory: the full model, the reduced model and the explicit Euler


% preallocation: so to have output in case of blowup
rel_err_var.InferredScheme = 0;  rel_err_var.Euler          = 0; 
TV_RMvsTrue = 0; TV_RM0vsTrue =0;  scheme_cmp = 'Euler'; 

%% run the inferred system
x0       = X(:,1); tN = length(X(1,:))-1; 
deltat   = rmInfo.deltat; 
[Xtraj ,blowupFlag]  = run_inferred_scheme(cvec,res,tN,x0,dWDeltat,rmInfo,sysInfo); 
if blowupFlag == 1; return; end 

%% compare traj's of rm and fm, and Explicit Euler
tInd = (1:1:tN+1);
fmDataInfo1    = fmDataInfo; 
fmDataInfo1.dt = deltat; 
fmDataInfo1.tN = tN; 

blowupRK4   = 0; blowupEuler =0; 
scheme_type = rmInfo.rm_type; 
if strcmp(scheme_type,'RK4')
    scheme_cmp = 'RK4'; 
    [~,X_Euler,blowupRK4]    = hybridRK4(sysInfo,fmDataInfo1,x0,dWDeltat); % hybridRK4   or forwardEuler
end
if ~strcmp(scheme_type, 'RK4') || blowupRK4 ==1
    scheme_cmp = 'Euler'; 
    fprintf('Running forward Euler with deltat=%i dt \n   ', rmInfo.obsgap); 
    [~,X_Euler,blowupEuler]  = forwardEuler(sysInfo,fmDataInfo1,x0,dWDeltat); % hybridRK4   or forwardEuler
end
if blowupEuler ==1;   X_Euler = 0*X_Euler; end


mmt2True = mean(X(1,:).^2); 
mmt2IS   = mean(Xtraj(1,:).^2); 
mmt2Euler= mean(X_Euler(1,:).^2); 
rel_err_var.InferredScheme = mmt2IS/mmt2True; 
rel_err_var.Euler          = mmt2Euler/mmt2True;

ACF_obsT  = 10; % Autocorrelation leap time in time units
gapseq   = [1, 2, 4, 10, 20, 40, 80, 120, 160,200];
obsgap   = gapseq(gapInd);  dt=fmDataInfo.dt;
timeLag   = floor(ACF_obsT/(obsgap*dt)); 
% compareStats(Xtraj(1,tInd),X(1,tInd),timeLag,deltat,estimator_filename,figpath,figname0,corr_x1); 
[TV_RMvsTrue,TV_RM0vsTrue] = compareStats3(Xtraj(1,tInd),X(1,tInd),X_Euler(1,tInd),timeLag,(obsgap*dt),rmInfo,scheme_cmp);

end
