function t_corr = temporal_corr(X,timeLag)
% temporal correlation of a time series X

[K,tN]  = size(X);

if ~timeLag; timeLag = min(ceil(tN/100),400); end
indx1   = 1:tN-timeLag;  

t_corr   = zeros(K,timeLag+1);

for k=1:K
    Xtemp   = X(k,indx1);
    for tt=1:timeLag +1
        indx2       = tt-1+ indx1;
        t_corr(k,tt) = mean(Xtemp.*X(k,indx2));
    end
end
% figure; plot(t_corr(1,:)./t_corr(1,1)); title('Temporal correlation of S'); 


end